module.exports = config = {
    name: "codetube",
    url: "localhost:3000",
    host: "localhost",
    port: 3000,
    minification: true, // javascript minification
    repositories: "repositories", // repository folder (relative from this dir)
    https: false, // or {key:…, cert:…}
    cluster: { // clustering
        workers: 1, // or false for #cpu-number
    },
    db: { // couchdb settings
        server: "localhost",
        port: 5984,
        name: "codetube",
        options: { // of cradle
            cache: true,
        },
    },
    session: function () {
        return new (require('couch-session'))({
            database: "codetube-session",
            server: "localhost",
            port: 5984,
        });
    },
    cache: {
        backend: function () {
            return new (require('flexcache/backend/redis').RedisBackend)() // you can pass options with ({db:"dbname", ...})
        },
        ttl: 400
    },
//     session: function () {
//         return require('connect-redis')(require('express'));
//     },
    socketio: {
        // flashblock requires setting up a policy port on 843
        //transports: ['websocket', 'flashsocket', 'xhr-polling', 'jsonp-polling', 'htmlfile'],
        transports: ['websocket', 'xhr-polling', 'jsonp-polling', 'htmlfile'],
        log_level: 2,
        heartbeat: {
            timeout: 5000,
            interval: 1000,
        },
        store: require('socket.io').MemoryStore,
//         store: require('socket.io').RedisStore,
        close_timeout: 500,
        minification: true,
        etag: true,
    },
    clone_url: {
        default: "http",
    },
    projects: {
        page_limit: 20,
    },
    users: {
        registration: true,
        page_limit: 20,
    },
    auth: {
        consumerKey: "codetube-consumerkey",
        consumerSecret: "codetube-consumersecret",
    },
    salt: {
        session: "ultrasecret!1elf",
        private: "megasecret42",
        public: "supersecret23",
    },
    githttpbackend: {
        enable: true,
    },
    gitdaemon: {
        host: "localhost", // codetube's git daemon proxy serve address
        port: 9418, // git protocoll port
        address: "localhost", // 'git daemon' serve address
        serve: 4000, // 'git daemon' serve port
        enable: true,
        pidfile: "/tmp/codetube-git-daemon.pid",
    },
    localization: {
        default: "en",
    },
    debug: { // debugging settings
        enable: false,
        profiler: false,
        stats: false,
        logger: false, // path to logs or false
    },
    cache: {
        enable: false,
        ttl: 24 * 60 * 60 * 1000,
    },
    links: { // allways visible links
        //"text": "url",
        blog: "http://blog.codetu.be/",
    },
};

